---
title: Create Custom CSR
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

[Custom Csrs](https://developers.cloudflare.com/api/typescript/resources/custom_csrs)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create Custom CSR

client.customCsrs.create(CustomCsrCreateParams {common\_name, country, locality, 9 more } params, RequestOptionsoptions?): [CustomCsrCreateResponse](<https://developers.cloudflare.com/api/typescript/resources/custom_csrs#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)>) {id, created\_at, key\_type, 11 more }

POST/{accounts\_or\_zones}/{account\_or\_zone\_id}/custom\_csrs

Generate a new custom Certificate Signing Request (CSR) for an account or zone. Cloudflare generates and securely stores the private key associated with the CSR.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account: SSL and Certificates Write`

##### ParametersExpand Collapse

<details>

<summary>

params: CustomCsrCreateParams {common\_name, country, locality, 9 more }

</summary>

common\_name: string

Body param: The common name (domain) for the CSR. Must be at most 64 characters.

maxLength64

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20common_name">Link to this property</a>

country: string

Body param: Two-letter ISO 3166-1 alpha-2 country code.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20country">Link to this property</a>

locality: string

Body param: City or locality name.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20locality">Link to this property</a>

organization: string

Body param: Organization name.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20organization">Link to this property</a>

sans: Array&lt;string&gt;

Body param: Subject Alternative Names for the CSR. At least one SAN is required.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20sans">Link to this property</a>

state: string

Body param: State or province name.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20state">Link to this property</a>

account\_id?: string

Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

zone\_id?: string

Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

description?: string

Body param: Optional description for the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20description">Link to this property</a>

<details>

<summary>

key\_type?: "rsa2048"| "p256v1"

Body param: Key algorithm to use for the CSR. Defaults to rsa2048 if not specified.

</summary>

One of the following:

"rsa2048"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20key_type%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

"p256v1"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20key_type%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20key_type">Link to this property</a>

name?: string

Body param: Human-readable name for the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20name">Link to this property</a>

organizational\_unit?: string

Body param: Organizational unit name.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20organizational_unit">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_csrs%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

CustomCsrCreateResponse {id, created\_at, key\_type, 11 more }

A custom Certificate Signing Request (CSR).

</summary>

id: string

Custom CSR identifier tag.

maxLength36

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

created\_at: string

When the CSR was created.

formatdate-time

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

<details>

<summary>

key\_type: "rsa2048"| "p256v1"

The key algorithm used to generate the CSR.

</summary>

One of the following:

"rsa2048"

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20key_type%20%3E%20(member)%200">Link to this property</a>

"p256v1"

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20key_type%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20key_type">Link to this property</a>

account\_tag?: string

Account identifier associated with this CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20account_tag">Link to this property</a>

common\_name?: string

The common name (domain) for the CSR.

maxLength64

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20common_name">Link to this property</a>

country?: string

Two-letter ISO 3166-1 alpha-2 country code.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20country">Link to this property</a>

csr?: string

The PEM-encoded Certificate Signing Request.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20csr">Link to this property</a>

description?: string

Optional description for the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

locality?: string

City or locality name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20locality">Link to this property</a>

name?: string

Human-readable name for the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

organization?: string

Organization name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20organization">Link to this property</a>

organizational\_unit?: string

Organizational unit name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20organizational_unit">Link to this property</a>

sans?: Array&lt;string&gt;

Subject Alternative Names included in the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20sans">Link to this property</a>

state?: string

State or province name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)%20%3E%20(property)%20state">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_csrs%20%3E%20(model)%20custom_csr_create_response%20%3E%20(schema)>)

### Create Custom CSR

TypeScript

HTTPTypeScriptPythonGoTerraform

```
import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const customCsr = await client.customCsrs.create({
  common_name: 'example.com',
  country: 'US',
  locality: 'San Francisco',
  organization: 'Cloudflare, Inc.',
  sans: ['example.com', 'www.example.com'],
  state: 'California',
  account_id: 'account_id',
});

console.log(customCsr.id);
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752",
    "created_at": "2024-01-15T10:30:00Z",
    "key_type": "rsa2048",
    "account_tag": "23e087bd19bc1d40ae95b6f297263ceb",
    "common_name": "example.com",
    "country": "US",
    "csr": "-----BEGIN CERTIFICATE REQUEST-----\nMIICYzCCAUsCAQAwHj...",
    "description": "CSR for example.com wildcard",
    "locality": "San Francisco",
    "name": "My Custom CSR",
    "organization": "Cloudflare, Inc.",
    "organizational_unit": "Engineering",
    "sans": [
      "example.com",
      "www.example.com"
    ],
    "state": "California"
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752",
    "created_at": "2024-01-15T10:30:00Z",
    "key_type": "rsa2048",
    "account_tag": "23e087bd19bc1d40ae95b6f297263ceb",
    "common_name": "example.com",
    "country": "US",
    "csr": "-----BEGIN CERTIFICATE REQUEST-----\nMIICYzCCAUsCAQAwHj...",
    "description": "CSR for example.com wildcard",
    "locality": "San Francisco",
    "name": "My Custom CSR",
    "organization": "Cloudflare, Inc.",
    "organizational_unit": "Engineering",
    "sans": [
      "example.com",
      "www.example.com"
    ],
    "state": "California"
  }
}
```